"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage, validator) {
    _classCallCheck(this, _class);

    this.storage = storage;
    this.packageValidator = validator;
  }

  /*
   * First validates if package is valid
   * Adds a version to the package in filesystem or creates a new package
   * Sends a 201 to let npm know package was published
   */


  _createClass(_class, [{
    key: "process",
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var packageData = httpRequest.body;

        if (!packageData._attachments) {
          _this.deprecateUpdater(packageData).then(function (result) {
            if (result) {
              httpResponse.status(200).send({
                ok: "packageJson updated"
              });
              resolve();
            } else {
              reject("420, error: cannot update");
            }
          });
        }

        _this.storage.isPackageAvailable(packageData._packageName, packageData._scope).then(function (result) {
          if (result === true) {
            _this.writePackage(httpRequest, httpResponse);
          } else {
            _this.writeNewPackage(httpRequest, httpResponse);
          }
        });
      }).catch(function (err) {
        httpResponse.send(err);
      });
    }
  }, {
    key: "deprecateUpdater",
    value: function deprecateUpdater(packageData) {
      var _this2 = this;

      return new Promise(function (resolve) {
        _this2.storage.updatePackageJson(packageData).then(function (data) {
          resolve(data);
        });
      });
    }
  }, {
    key: "writePackage",
    value: function writePackage(httpRequest, httpResponse) {
      var _this3 = this;

      var distTag = void 0;
      console.log(httpRequest.body['dist-tags']);

      for (var key in httpRequest.body['dist-tags']) {
        distTag = key;
      }

      this.packageValidator.hasDistTag(httpRequest.body, distTag).then(function (result) {
        if (result === true) {
          _this3.packageValidator.isVersionHigher(httpRequest.body._packageName, httpRequest.body._scope, httpRequest.body['dist-tags'][distTag], distTag).then(function (result) {
            if (result === false) {
              httpResponse.send("423, cannot publish, given version is invalid");
            } else {
              _this3.storage.writePackage(httpRequest.body).then(function (result) {
                if (result === true) {
                  httpResponse.status(201);
                  httpResponse.send({
                    ok: "package published"
                  });
                } else {
                  httpResponse.status(500);
                  httpResponse.send({
                    message: "error while writing package"
                  });
                }
              });
            }
          });
        } else {
          httpResponse.status(403);
          httpResponse.send({ message: "cannot publish, given version is invalid" });
        }
      });
    }
  }, {
    key: "writeNewPackage",
    value: function writeNewPackage(httpRequest, httpResponse) {
      var packageData = httpRequest.body;
      this.storage.writeNewPackage(packageData).then(function (result) {
        if (result === true) {
          httpResponse.status(201);
          httpResponse.send({
            ok: "package published"
          });
        } else {
          httpResponse.status(500);
          httpResponse.send({ message: "error while writing package" });
        }
      });
    }
  }]);

  return _class;
}();

exports.default = _class;